//+------------------------------------------------------------------+
//|                                               EURUSD Scalper.mq4 |
//|                                   Copyright  2009, Lakshmi Inc. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern double SLM=2;
extern int TPM=5;
extern int TrailingStop=175;
extern double Lots=0.1;
extern int Rsi_Period1=5;
extern int Rsi_Period2=5;
extern int RsiEMA_Period1=5;
extern int RsiEMA_Period2=5;
extern int ma1=3;
extern int ma2=14;
extern int ma3=25;
extern int Arr_LB=6;   // Look back period for RSI-Div_arrows
extern int PMA_LB=6;   // Look back period for Price crossing MA2
extern int MAX_LB=6;
double ArrGap=0.0005;
int i=1;


//-- RSI-Div-Arrows ==================================================
//---- buffers
double B1, B2, B3, B4, B5, B6, B7, B8, B9, B10;
double MA1, MA2, MA3, CMA1, CMA2, CMA3, PMA1, PMA2, PMA3, Sig, MASig;
double emaFactor1, emaFactor2;
double oldRSI1, oldRSI2;
double RSI_BuyAllow;
double MA_BuyAllow;
double MAX_BuyAllow;
double RSI_SellAllow;
double MA_SellAllow;
double MAX_SellAllow;
//---- variables



//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
  //RSI-Div-Arrows ==================================================
   //---- initialisations
   
    emaFactor1 = 2.0 / (RsiEMA_Period1 + 1);
    emaFactor2 = 2.0 / (RsiEMA_Period2 + 1);
//----   
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   int total=OrdersTotal(), cnt, i, j, k, l, m, n, b, limit, Now;
   int TBO=0;
   int TSO=0;
   int TM=Time[0];
   bool ticket;
   double Spread;
   Spread = MarketInfo(Symbol(),MODE_SPREAD) * Point;
//+------------------------------------------------------------------+
//| check open orders                                                |
//+------------------------------------------------------------------+
   for(cnt=0;cnt<total;cnt++)
   {
   OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            TBO=TBO+1; // Add 1 to Buy Order Count
           }
         else
           {
            TSO=TSO+1; // Add 1 to Sell Order Count
           }
        }
   }   

//+------------------------------------------------------------------+
//| indicators                                                       |
//+------------------------------------------------------------------+
   double UB=RSI_Div_Up(1);
   double DB=RSI_Div_Dn(1);
   
   double PDI=iADX(0,0,14,PRICE_CLOSE,MODE_PLUSDI,0);
   double MDI=iADX(0,0,14,PRICE_CLOSE,MODE_MINUSDI,0);
   double ATR=iATR(NULL,0,16,0);
   double SL=SLM*ATR;      
   double TP=TPM*ATR;
//   Print( "UP Buffer=",UB,"Down Buffer=",DB);
//   Print("Up Buffer =", UB, "Down Buffer=",DB);

//+------------------------------------------------------------------+
//| check long  RSI-Div-Arrow                                        |
//+------------------------------------------------------------------+    
   for(i=0;i<=Arr_LB;i++)
      {
      if(RSI_Div_Up(i)>0)
        {
        int BuyAllow=1;
        int SellAllow=0;
        }
      else
        {
        BuyAllow=0;
        }
      }
//+------------------------------------------------------------------+
//| check short RSI-Div-Arrow                                        |
//+------------------------------------------------------------------+ 
   for(i=0;i<=Arr_LB;i++)
      {
      if(RSI_Div_Dn(i)>0)
        {
        SellAllow=1;
        BuyAllow=0;
        }
      else
        {
        SellAllow=0;
        }
      }

   {
   for(k=0;k<=PMA_LB;k++)
     {
     if(PriceMA_X_Up(k)>0)
       {
       MA_BuyAllow=1;
       MA_SellAllow=0;
       }
       else
       {
       MA_BuyAllow=0;
       }
     }
//+------------------------------------------------------------------+
//| check short price cross MA                                       |
//+------------------------------------------------------------------+ 
   for(l=0;l<=PMA_LB;l++)
     {
     if(PriceMA_X_Dn(l)>0)
       {
       MA_SellAllow=1;
       MA_BuyAllow=0;
       }
       else
       {
       MA_SellAllow=0;
       }
     }
//+------------------------------------------------------------------+
//| check long MA cross                                              |
//+------------------------------------------------------------------+ 
   for(m=0;m<=MAX_LB;m++)
     {
     if(MA_X_Up(m)>0)
       {
       MAX_BuyAllow=1;
       MAX_SellAllow=0;
       }
       else
       {
       MAX_BuyAllow=0;
       }
     }
//+------------------------------------------------------------------+
//| check short MA cross                                             |
//+------------------------------------------------------------------+ 
   for(n=0;n<=MAX_LB;n++)
     {
     if(MA_X_Dn(n)>0)
       {
       MAX_SellAllow=1;
       MAX_BuyAllow=0;
       }
       else
       {
       MAX_SellAllow=0;
       }
     }
   }
     
//Print("Sell = ", MAX_SellAllow,",", MA_SellAllow,",", RSI_SellAllow); 
//Print("Buy =", MAX_BuyAllow,",", MA_BuyAllow,",", RSI_BuyAllow); 
//+------------------------------------------------------------------+
//| check long                                                       |
//+------------------------------------------------------------------+      
   if
      ( TBO==0 && TM!=Now  && MA_BuyAllow==1 && RSI_BuyAllow==1  )
      {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Ask-SL,Ask+TP,NULL,16384,0,Green);
         Now=OrderOpenTime();
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice(),"Time ",OrderOpenTime());
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
        }
//+------------------------------------------------------------------+
//| check short                                                      |
//+------------------------------------------------------------------+      
    if
       ( TSO==0 && TM!=Now  && MA_SellAllow==1 && RSI_SellAllow==1  )
       {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Bid+SL,Bid-TP,NULL,16384,0,Red);
         Now=OrderOpenTime();
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice(),"Time ",OrderOpenTime());
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
   
//+------------------------------------------------------------------+
//| modify/close orders                                              |
//+------------------------------------------------------------------+         
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // should it be closed?
            if(TSO==1)
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                 return(0); // exit
                }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }   
           }
         else // go to short position
           {
            // should it be closed?
            if(TBO==1)
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
               return(0); // exit
              }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              } 
           }
        }
     }   
         
//----
   return(0);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Function Calls: RSI_EMA1                                         |
//+------------------------------------------------------------------+      
double RSI_EMA1(int pos, int RSI_Period, double emaFactor, double& oldRSI)
{
double curRSI;
   if(pos==Bars-2) 
      curRSI = iRSI(Symbol(),Period(),RSI_Period,PRICE_CLOSE,pos+1);
   else   
      curRSI = iRSI(Symbol(),Period(),RSI_Period,PRICE_CLOSE,pos)*emaFactor + oldRSI*(1-emaFactor);
      
      
   oldRSI = curRSI;   
   return(curRSI);
}

//+------------------------------------------------------------------+
//| Function Calls: RSI_DIV_ARROWS_UP                                |
//| returns 1 if up arrow on last candle                             |
//+------------------------------------------------------------------+      
double RSI_Div_Up(int k)
{
    B1 = RSI_EMA1(k, Rsi_Period1, emaFactor1, oldRSI1); //-- call FUNCTION
    B2 = RSI_EMA1(k, Rsi_Period2, emaFactor2, oldRSI2); //-- call FUNCTION
    B3 = RSI_EMA1(k+1, Rsi_Period1, emaFactor1, oldRSI1); //-- call FUNCTION
    B4 = RSI_EMA1(k+1, Rsi_Period2, emaFactor2, oldRSI2); //-- call FUNCTION

    if((B1>B2 && B3<B4)) 
      {
         B5=0;
         B6=1;      //-up
      }
      else
      {
         B5=0;
         B6=0;
      }
return(B6);
}


//+------------------------------------------------------------------+
//| Function Calls: RSI_DIV_ARROWS_DOW                               |
//| returns 1 if down arrow on last candle                           |
//+------------------------------------------------------------------+
double RSI_Div_Dn(int k)
{
    B1 = RSI_EMA1(k, Rsi_Period1, emaFactor1, oldRSI1); //-- call FUNCTION
    B2 = RSI_EMA1(k, Rsi_Period2, emaFactor2, oldRSI2); //-- call FUNCTION
    B3 = RSI_EMA1(k+1, Rsi_Period1, emaFactor1, oldRSI1); //-- call FUNCTION
    B4 = RSI_EMA1(k+1, Rsi_Period2, emaFactor2, oldRSI2); //-- call FUNCTION
   
    
    if((B1<B2 && B3>B4))
      {
         B5=1;                  //-dn
         B6=0;
      }
      else
      {
         B5=0;
         B6=0;
      }
return(B5);
}

//+------------------------------------------------------------------+
//| Function Calls: Price Cross MA                                   |
//| returns 1 if buy signal , 0 otherwise                            |
//+------------------------------------------------------------------+

double PriceMA_X_Up(int k)
{
   MA1=iMA(0,0,ma1,0,MODE_EMA,PRICE_CLOSE,k+1);
   MA2=iMA(0,0,ma2,0,MODE_EMA,PRICE_CLOSE,k+1);
   MA3=iMA(0,0,ma3,0,MODE_EMA,PRICE_CLOSE,k+1);
   
   if( Open[k+1]<MA2 && Close[k+1]>MA2)
     {
     Sig=1;
     }
   else
     {
     Sig=0;
     }
return(Sig);
} 

//+------------------------------------------------------------------+
//| Function Calls: Price Cross MA                                   |
//| returns 1 if sell signal , 0 otherwise                           |
//+------------------------------------------------------------------+

double PriceMA_X_Dn(int k)
{
   MA1=iMA(0,0,ma1,0,MODE_EMA,PRICE_CLOSE,k+1);
   MA2=iMA(0,0,ma2,0,MODE_EMA,PRICE_CLOSE,k+1);
   MA3=iMA(0,0,ma3,0,MODE_EMA,PRICE_CLOSE,k+1);

   if( Open[k+1]>MA2 && Close[k+1]<MA2)
     {
     double Sig1=-1;
     }
   else
     {
     Sig1=0;
     }
return(Sig1);
} 

//+------------------------------------------------------------------+
//| Function Calls: MA1 Cross MA2                                    |
//| returns 1 if buy signal, -1 if sell signal, 0 otherwise          |
//+------------------------------------------------------------------+

double MA_X_Up(int k)
{

   MA1=iMA(0,0,ma1,0,MODE_EMA,PRICE_CLOSE,k+1);
   MA2=iMA(0,0,ma2,0,MODE_EMA,PRICE_CLOSE,k+1);
   MA3=iMA(0,0,ma3,0,MODE_EMA,PRICE_CLOSE,k+1);
   PMA1=iMA(0,0,ma1,0,MODE_EMA,PRICE_CLOSE,k+2);
   PMA2=iMA(0,0,ma2,0,MODE_EMA,PRICE_CLOSE,k+2);
   PMA3=iMA(0,0,ma3,0,MODE_EMA,PRICE_CLOSE,k+2);
   
   if(PMA1<PMA3 && PMA1<PMA2 && MA1>MA2)
     {
     MASig=1;
     }
   else
     {
     MASig=0;
     }
return(MASig);
} 

//+------------------------------------------------------------------+
//| Function Calls: MA1 Cross MA2                                    |
//| returns 1 if buy signal, -1 if sell signal, 0 otherwise          |
//+------------------------------------------------------------------+

double MA_X_Dn(int k)
{

   MA1=iMA(0,0,ma1,0,MODE_EMA,PRICE_CLOSE,k+1);
   MA2=iMA(0,0,ma2,0,MODE_EMA,PRICE_CLOSE,k+1);
   MA3=iMA(0,0,ma3,0,MODE_EMA,PRICE_CLOSE,k+1);
   PMA1=iMA(0,0,ma1,0,MODE_EMA,PRICE_CLOSE,k+2);
   PMA2=iMA(0,0,ma2,0,MODE_EMA,PRICE_CLOSE,k+2);
   PMA3=iMA(0,0,ma3,0,MODE_EMA,PRICE_CLOSE,k+2);
   
   if(PMA1>PMA3 && PMA1>PMA2 && MA1<MA2)
     {
     double MASig1=1;
     }
   else
     {
     MASig1=0;
     }
return(MASig1);
} 